import SwiftUI

struct ContentView: View {
    @State private var player = Player(
        url: URL(string: "https://devstreaming-cdn.apple.com/videos/streaming/examples/img_bipbop_adv_example_ts/master.m3u8")!
    )

    var body: some View {
        Button(label, action: player.togglePlayPause)
            .onReceive(player.playbackStatePublisher()) { state in
                print("--> state: \(state), isMainThread = \(Thread.isMainThread)")
            }
    }

    private var label: LocalizedStringKey {
        player.playbackState == .playing ? "Pause" : "Play"
    }
}

#Preview {
    ContentView()
}
